/*
 * GStreamer
 * Copyright 2007 Ole Andr Vadla Ravns <ole.andre.ravnas@tandberg.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GST_OSXVIDEOSRC_H__
#define __GST_OSXVIDEOSRC_H__

#include <gst/gst.h>
#include <gst/base/gstpushsrc.h>
#include <ApplicationServices/ApplicationServices.h> /* FIXME: get rid of QuickDraw */
#include <CoreServices/CoreServices.h>
#include <Quicktime/Quicktime.h>

G_BEGIN_DECLS

/* #defines don't like whitespacey bits */
#define GST_TYPE_OSXVIDEOSRC \
  (gst_osxvideosrc_get_type())
#define GST_OSXVIDEOSRC(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),GST_TYPE_OSXVIDEOSRC,GstOSXVideoSrc))
#define GST_OSXVIDEOSRC_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),GST_TYPE_OSXVIDEOSRC,GstOSXVideoSrcClass))
#define GST_IS_OSXVIDEOSRC(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),GST_TYPE_OSXVIDEOSRC))
#define GST_IS_OSXVIDEOSRC_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),GST_TYPE_OSXVIDEOSRC))

typedef struct _GstOSXVideoSrc      GstOSXVideoSrc;
typedef struct _GstOSXVideoSrcClass GstOSXVideoSrcClass;

struct _GstOSXVideoSrc
{
  GstPushSrc pushsrc;

  SeqGrabComponent seq_grab;
  SGChannel video_chan;
  ComponentInstance vd;

  guint seq;
};

struct _GstOSXVideoSrcClass 
{
  GstPushSrcClass parent_class;
};

GType gst_osxvideosrc_get_type (void);

G_END_DECLS

#endif /* __GST_OSXVIDEOSRC_H__ */
